.486
.model flat, stdcall
option casemap: none

; API functions
; ------------------------------------------------------------------------------
include \masm32\include\windows.inc
include \masm32\include\masm32.inc
include \masm32\include\gdi32.inc
include \masm32\include\user32.inc
include \masm32\include\kernel32.inc
include \masm32\include\advapi32.inc
include \masm32\include\Comctl32.inc
include \masm32\include\comdlg32.inc
include \masm32\include\shell32.inc
include \masm32\include\oleaut32.inc
include \masm32\include\ole32.inc
include \masm32\include\dialogs.inc
include \masm32\include\winmm.inc
include \masm32\include\msimg32.inc
   
   
includelib \masm32\lib\masm32.lib
includelib \masm32\lib\gdi32.lib
includelib \masm32\lib\user32.lib
includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\advapi32.lib
includelib \masm32\lib\Comctl32.lib
includelib \masm32\lib\comdlg32.lib
includelib \masm32\lib\shell32.lib
includelib \masm32\lib\oleaut32.lib
includelib \masm32\lib\ole32.lib
includelib \masm32\lib\winmm.lib
includelib \masm32\lib\msimg32.lib
   
include \masm32\MACROS\MACROS.asm
   
; Prototype 
; ------------------------------------------------------------------------------
DialogProc PROTO : HWND, : UINT, : WPARAM, : LPARAM
WndProc    PROTO :DWORD, :DWORD, :DWORD, :DWORD
; ------------------------------------------------------------------------------
; Macros
; ------------------------------------------------------------------------------
m2m MACRO M1, M2
	push M2
	pop  M1
ENDM


GETV MACRO dVar
	mov eax,dVar 
  EXITM <eax>
ENDM
; ------------------------------------------------------------------------------
.const

; Resource ids
; ------------------------------------------------------------------------------
IDD_DLG1  		equ 101
IDI_ICON        equ 200
COLORDLG		equ 00000000h ; Dialog colour (Natural window coour is 00D8E9ECh)

TIMER1 equ 1
Stars equ 200 ; number of stars

; Required data

.data
szTitle       TCHAR "TEST window", 0
MyRect RECT <0,0,PictureW,PictureH>
   
noir dd 0000000h
   
pt dd Stars dup (0,0,0) ;x,y,z+color
   
ptX dd 0
ptY dd 0
   
random dd 0
   
num256 REAL4 256.00 ; starting cluster size


.data?

hInstance HINSTANCE ?
hIcon     HICON     ?
rClientWindow RECT <?>
WindowRect   RECT  <?>
hbmp	HANDLE		?
chdc		HDC		?
hBgColor   HBRUSH	?
hpen        HPEN	?
hmainDC  dd ?
hmainbmp dd ?
PictureW RECT  <?>
PictureH RECT  <?>
PosRct	RECT   <?>
.code

start:
INVOKE GetModuleHandle, NULL
mov hInstance, eax

INVOKE LoadIcon, eax, IDI_ICON 
mov hIcon, eax
INVOKE InitCommonControls
; ---------------------------------------------
;   Call the dialog box stored in resource file
; ---------------------------------------------
INVOKE DialogBoxParam, hInstance, IDD_DLG1 , NULL, ADDR DialogProc, 0
INVOKE ExitProcess, 0


; Dialog procedure
; ------------------------------------------------------------------------------
DialogProc proc hWnd: HWND, uMsg: UINT, wParam: WPARAM, lParam: LPARAM


 .IF uMsg == WM_INITDIALOG

  INVOKE SetWindowText, hWnd, addr szTitle 
  INVOKE SendMessage, hWnd, WM_SETICON,ICON_SMALL, hIcon
  
    .ELSEIF uMsg == WM_COMMAND
    
      .ELSEIF uMsg == WM_CLOSE
    INVOKE EndDialog, hWnd, 0
 .ENDIF

    xor eax,eax
  ret
DialogProc endp
 ; -------------------------------------------------------------------------
    WndProc PROC uses edx ecx ebx esi edi hWnd :HWND,uMsg :DWORD,wParam :DWORD,lParam :DWORD
    ; -------------------------------------------------------------------------
   
    LOCAL hdc:HDC
    LOCAL ps:PAINTSTRUCT
   
    mov eax, uMsg
  ; ################################# creats colour window		
		invoke CreateSolidBrush,COLORDLG
	mov hBgColor,eax
; ################################# creats colour window	   
 		invoke GetClientRect,hWnd,ADDR WindowRect
	mov hdc,FUNC(GetDC,hWnd)
	mov chdc,FUNC(CreateCompatibleDC,hdc); creats window
	mov hbmp,FUNC(CreateCompatibleBitmap,hdc,WindowRect.right,WindowRect.bottom); creats window
		invoke SelectObject,chdc,hbmp
	mov rClientWindow.top,1
	mov rClientWindow.left,1
	m2m rClientWindow.right,WindowRect.right
	m2m rClientWindow.bottom,WindowRect.bottom    
	dec rClientWindow.bottom
	dec rClientWindow.right
		;invoke FillRect,chdc,ADDR WindowRect,hBgColor ; color for about title
		;invoke SelectObject,chdc,hpen; Draws a Frame  
		invoke IntersectClipRect,chdc,rClientWindow.left,rClientWindow.top,rClientWindow.right,rClientWindow.bottom	
    ; -------------------------------------------------------------------------
    .IF eax == WM_PAINT
   
    invoke BeginPaint,hWnd, ADDR ps
    mov hdc,eax
   invoke FillRect,chdc,ADDR rClientWindow,hBgColor
    ; ------------------------------------------------------------- PIXEL
    xor esi,esi
   
    @starfield:
   
    call starfield
   
    invoke SetPixel, hmainDC, ptX, ptY, eax
   
    add esi,12 ; next stars
    cmp esi,Stars*12 ; end?
    jne @starfield
   
    ; ------------------------------------------------------------- PIXEL
   
    	invoke BitBlt,hdc,0,0,WindowRect.right,WindowRect.bottom,chdc,0,0,SRCCOPY
		invoke EndPaint,hWnd,addr ps
   
    ; -------------------------------------------------------------------------
    .ELSEIF eax == WM_KEYDOWN
   
    cmp wParam, VK_ESCAPE
    je destroy
   
   
    ; -------------------------------------------------------------------------
    .ELSEIF eax == WM_TIMER
   
    invoke FillRect, hmainDC, addr MyRect,noir
    invoke RedrawWindow, hWnd, addr MyRect, 0, RDW_INVALIDATE
   
    ; -------------------------------------------------------------------------
    .ELSEIF eax == WM_CREATE
   
    invoke CreateSolidBrush,noir
    mov noir,eax
   
    invoke SetTimer, hWnd, TIMER1, 10, NULL
    ;  main
   
    invoke GetDC, hWnd
    mov hdc, eax
   
   ; mov esi,PictureW
   ; mov edi,PictureH
   mov eax,PosRct.left
	add eax, 130
	mov ebx,PosRct.top
	add ebx, 100
   
    invoke CreateCompatibleDC, hdc
    mov dword ptr [hmainDC],eax
   
    invoke CreateCompatibleBitmap, hdc, esi, edi
    mov dword ptr [hmainbmp],eax
   
    invoke SelectObject, [hmainDC], eax
   
    invoke ReleaseDC,hWnd, hdc
    ;  main
   
   
   
   
   
    ; ?==?==?==?==?==?==?==?==?==?==?==?==?==?==?==?==?==?==? Create stars coord.
    invoke GetTickCount
    mov random,eax
   
    xor esi,esi
   
    CREATE_STARS:
   
    push eax
   
    imul ax,cx
    movsx eax,ax
    mov edx,eax
    shr edx,8
    mov ah,dh
    add al,3
    mov dword ptr [pt+esi],eax
   
    pop eax
    xor eax,[$+esi]
    movsx eax,ax
    mov edx,eax
    shr edx,8
    mov ah,dh
    mov dword ptr [pt+esi+4], eax
   
   
    imul ax,cx
    xor ax,si
    mov random,eax
   
   
    mov ecx,eax
    mov ch,1
    and ecx,0fffh
    mov dword ptr [pt+esi+8], ecx
   
    add esi,12
    cmp esi,Stars*12
    jne CREATE_STARS
    ; ?==?==?==?==?==?==?==?==?==?==?==?==?==?==?==?==?==?==? Create stars coord.
   
   
    .ELSEIF eax == WM_CLOSE
    destroy:
    invoke PostQuitMessage,NULL
    invoke DeleteDC, [hmainDC]
    invoke DeleteObject, [hmainbmp]
    invoke DeleteObject, noir
    invoke KillTimer, hWnd, TIMER1
    .ENDIF
   
   
    xor eax,eax
    invoke DefWindowProc,hWnd,uMsg,wParam,lParam
    ret
   
   
    starfield:
   
    finit
   
    dec dword ptr [pt+esi+8]
   
    fild word ptr [pt+esi+8] ;z
    fld num256
   
    fild dword ptr [pt+esi] ;x
    fmul st(0),st(1)
    fdiv st(0),st(2)
    fistp dword ptr [ptX]
    ;add dword ptr [ptX],PictureW/2 ; center
   
   
    fild dword ptr [pt+esi+4] ;y
    fmul st(0),st(1)
    fdiv st(0),st(2)
    fistp dword ptr [ptY]
   ; add dword ptr [ptY],PictureH/2
   
   
   
    ;.IF [ptX] > PictureW || [ptY] > PictureH ; check the position
   ; call CHANGE_STARS
   ; .ENDIF
   
   
    xor eax,eax
    mov al,byte ptr [pt+esi+8+3] ; color
    mov ah,al
    shl eax,8
    mov al,ah
   
   
    .IF byte ptr [pt+esi+8+3] != 0FFh ; color white max
    inc byte ptr [pt+esi+8+3]
    .ENDIF
   
   
    retn
   
   
    CHANGE_STARS: ;change stars coord.
   
    mov eax, random
   
    push eax
   
    imul ax,cx
    movsx eax,ax
    mov edx,eax
    shr edx,8
    mov ah,dh
    add al,3
    mov dword ptr [pt+esi],eax
   
    pop eax
    xor eax,[$+esi]
    movsx eax,ax
    mov edx,eax
    shr edx,8
    mov ah,dh
    mov dword ptr [pt+esi+4], eax
   
   
    imul ax,cx
    xor ax,si
    mov random,eax
   
   
    mov ecx,eax
    mov ch,1
    and ecx,0fffh
    mov dword ptr [pt+esi+8], ecx ; fface z et raz la couleur
   
   
    retn
    ;-------------------------------------------------------------------------
    WndProc ENDP
    ; -------------------------------------------------------------------------
   
   
    ; -------------------------------------------------------------------------
    END start
    ; -------------------------------------------------------------------------
end start