.486
.model flat, stdcall
option casemap: none

; API functions
; ------------------------------------------------------------------------------
include  \masm32\include\windows.inc
include  \masm32\include\user32.inc
include  \masm32\include\kernel32.inc
include  \masm32\include\comctl32.inc
include  \masm32\include\masm32.inc
include  \masm32\include\shell32.inc
include  \masm32\include\comdlg32.inc
include  \masm32\include\gdi32.inc
include  \masm32\include\advapi32.inc

includelib  \masm32\lib\user32.lib
includelib  \masm32\lib\kernel32.lib
includelib  \masm32\lib\comctl32.lib
includelib  \masm32\lib\masm32.lib
includelib  \masm32\lib\shell32.lib
includelib  \masm32\lib\comdlg32.lib
includelib  \masm32\lib\gdi32.lib
includelib  \masm32\lib\advapi32.lib

include \masm32\macros\macros.asm
; ------------------------------------------------------------------------------

; Prototype 
; ------------------------------------------------------------------------------
DialogProc     PROTO : HWND, : UINT, : WPARAM, : LPARAM
NouvelleEtoile PROTO :DWORD ; New Star
Random         PROTO :DWORD
; Macros
; ------------------------------------------------------------------------------
m2m MACRO M1, M2
	push M2
	pop  M1
ENDM


GETV MACRO dVar
	mov eax,dVar 
  EXITM <eax>
ENDM
; ------------------------------------------------------------------------------
.const
; Resource ids
; ------------------------------------------------------------------------------
IDD_DLG1  	  equ 101
IDI_ICON      equ 200


COLORDLG		equ 00000000h ; Dialog colour (Natural window coour is 00D8E9ECh)
;
NbEtoiles equ 1000 ; No. Stars
TailleStructEtoile equ 28 ;Size Struct Star
VitesseMin equ 1 ; Low Speed or speedmin
VitesseMax equ 10 ;Max speed or speedmax
;
; Required data

.data
szTitle    db "Starfieldblank", 0
;
EstNvEtoile db FALSE ;Eastern Star Nv
Vitesse dd 2 ;speed
AfficheTraine db TRUE ;Drive type displayed or Displays Trolling
;

.data?
hInstance	dd	?
hIcon     HICON ?
brush		dd	?
hBgColor     	HBRUSH	 ?
WindowRect    	RECT	<?>
rStarfield		RECT	<?>
rClientWindow	RECT	<?>
PosRct		RECT		<?>
hbmp		HANDLE		 ?
chdc		HDC		     ?
TimerID		DWORD		 ?
;
Xfenetre dd ? ;window
Yfenetre dd ?
Xfenetrediv2 dd ?
Yfenetrediv2 dd ?
hEtoiles HANDLE ? ;H Stars
pEtoiles dd ? ;P Stars
hArrPlan dd ?
NombrePrRandom dd ? ;Random Name Pr
rect RECT <?, ?, ?, ?>
;

.code

start:
INVOKE GetModuleHandle, NULL
mov hInstance, eax

INVOKE LoadIcon, eax, IDI_ICON 
mov hIcon, eax
INVOKE InitCommonControls
; ---------------------------------------------
;   Call the dialog box stored in resource file
; ---------------------------------------------
INVOKE DialogBoxParam, hInstance, IDD_DLG1 , NULL, ADDR DialogProc, 0
INVOKE ExitProcess, 0

; Dialog procedure
; ------------------------------------------------------------------------------
DialogProc proc hWnd: HWND, uMsg: UINT, wParam: WPARAM, lParam: LPARAM

LOCAL	ps:PAINTSTRUCT
LOCAL	hdc:HDC
  mov		eax,uMsg
.IF eax == WM_INITDIALOG
INVOKE SendMessage, hWnd, WM_SETICON,ICON_SMALL, hIcon  
INVOKE SetWindowText, hWnd, addr szTitle 



  mov		eax,uMsg
.ELSEIF eax ==  WM_CREATE
                .ELSEIF eax == WM_COMMAND
     mov		eax,wParam
		and		eax,0FFFFh
; ################################# creats colour window		
INVOKE CreateSolidBrush,COLORDLG; <-creats colour window!!!		
mov hBgColor,eax
INVOKE GetClientRect,hWnd,addr WindowRect
mov hdc,FUNC(GetDC,hWnd)
mov chdc,FUNC(CreateCompatibleDC,hdc); creats window
mov hbmp,FUNC(CreateCompatibleBitmap,hdc,WindowRect.right,WindowRect.bottom); creats window
INVOKE SelectObject,chdc,hbmp
mov rClientWindow.left, 0
mov rClientWindow.top, 0
push Xfenetre
pop rClientWindow.right
push Yfenetre
pop rClientWindow.bottom
invoke GlobalAlloc, GMEM_MOVEABLE or GMEM_ZEROINIT, NbEtoiles * TailleStructEtoile
mov hEtoiles, eax
invoke GlobalLock, hEtoiles
mov pEtoiles, eax
;invoke ShowCursor, FALSE
.ELSEIF eax == WM_DESTROY
;invoke ShowCursor, TRUE
invoke GlobalUnlock, pEtoiles
invoke GlobalFree, hEtoiles
INVOKE EndDialog, hWnd, NULL

.ELSEIF eax == WM_KEYDOWN
.IF eax == VK_ESCAPE
invoke SendMessage, hWnd, WM_DESTROY, NULL, NULL
.ELSEIF eax == VK_PGDN
.IF Vitesse != VitesseMin
dec Vitesse
.ENDIF
.ELSEIF eax == VK_PGUP
.IF Vitesse != VitesseMax
inc Vitesse
.ENDIF
.ELSEIF eax == VK_T
.IF AfficheTraine
 mov AfficheTraine, FALSE
.ELSE
mov AfficheTraine, TRUE
.ENDIF
.ENDIF

.if eax == WM_PAINT
invoke BeginPaint, hWnd, ADDR ps
mov hdc, eax
invoke CreateCompatibleDC, hdc
mov chdc, eax
invoke CreateCompatibleBitmap, hdc, Xfenetre, Yfenetre
mov hbmp, eax
invoke SelectObject, chdc, hbmp
invoke FillRect, chdc, OFFSET rect, hArrPlan
.ENDIF
xor ecx, ecx
.WHILE ecx != NbEtoiles ;NbEtoile=No. Stars
mov eax, TailleStructEtoile ;TailleStructEtoile=Size Struct Star
mul ecx
add eax, pEtoiles
mov ebx, eax
;-----------------------
;----------------------------------------------;
;--- CHECK IF THE STAR IS ALWAYS GOOD ---;
mov eax, Vitesse
.IF dword ptr [ebx + 8] <= eax
push ecx
invoke NouvelleEtoile, ebx  ;NouvelleEtoile=New Star
pop ecx
mov EstNvEtoile, TRUE
.ENDIF
;----------------------------------------------;
;--- REPLACEMENT OF OLD ADDRESS ---;
.IF AfficheTraine ; AfficheTraine=Displays Trolling or Drive type displayed???
push dword ptr [ebx + 12]
pop dword ptr [ebx + 20]
push dword ptr [ebx + 16]
pop dword ptr [ebx + 24]
.ENDIF
;----------------------------------------;
;--- CALCULATION OF NEW ADDRESS ---;
mov eax, Vitesse     ; Vitesse = Speed
sub dword ptr [ebx + 8], eax
mov eax, dword ptr [ebx]
shl eax, 8
cdq
idiv dword ptr [ebx + 8]
add eax, Xfenetrediv2
mov dword ptr [ebx + 12], eax
mov eax, dword ptr [ebx + 4]
shl eax, 8
cdq
idiv dword ptr [ebx + 8]
add eax, Yfenetrediv2
mov dword ptr [ebx + 16], eax
;---------------------------;
;--- CORRECTION OF BUGS ---;
.IF AfficheTraine && EstNvEtoile ;Eastern Star Nv
push dword ptr [ebx + 12]
pop dword ptr [ebx + 20]
push dword ptr [ebx + 16]
pop dword ptr [ebx + 24]
mov EstNvEtoile, FALSE
.ENDIF
;--------------------------------------------------------------------;
;--- CHECK IF THE STAR IS ALWAYS IN THE LIMITS OF THE SCREEN ---;
mov eax, Xfenetre
mov edx, Yfenetre    ;fenetre=window
.IF dword ptr [ebx + 12] < 0 || dword ptr [ebx + 12] > eax || dword ptr [ebx + 16] < 0 || dword ptr [ebx + 16] > edx
mov dword ptr [ebx + 8], 0
.ENDIF
push ecx
;---------------------------;
;--- COLOR OF THE STAR ---;
xor eax, eax
mov ah, cl
mov al, ah
shl eax, 8
mov al, ah
invoke CreatePen, PS_SOLID, NULL, eax
push eax
invoke SelectObject, chdc, eax
;--------------------------;
;--- DRAWING FROM THE STAR ---;
push NULL
.IF AfficheTraine
push dword ptr [ebx + 24]
push dword ptr [ebx + 20]
.ELSE
mov eax, dword ptr [ebx + 16]
inc eax
push eax
push dword ptr [ebx + 12]
.ENDIF
push  chdc
call MoveToEx
invoke LineTo,  chdc, dword ptr [ebx + 12], dword ptr [ebx + 16]
pop eax
invoke DeleteObject, eax
pop ecx
.ENDW
invoke BitBlt, hdc, 0, 0, Xfenetre, Yfenetre, chdc, 0, 0, SRCCOPY
;INVOKE BitBlt,hdc,0,0,WindowRect.right,WindowRect.bottom,chdc,0,0,SRCCOPY
invoke DeleteObject, hbmp
invoke DeleteDC, chdc
invoke EndPaint, hWnd, ADDR ps ;<- Nedded to create Black screen
 .ELSE
  invoke DefWindowProc, hWnd, uMsg, wParam, lParam
ret
.ENDIF
 xor eax, eax
ret

DialogProc endp
NouvelleEtoile PROC uses ebx pEtoile:DWORD
mov ebx, pEtoile
invoke Random, Xfenetre
sub eax, Xfenetrediv2
mov dword ptr [ebx], eax
invoke Random, Yfenetre
sub eax, Yfenetrediv2
mov dword ptr [ebx + 4], eax
mov dword ptr [ebx + 8], 256
push Xfenetrediv2
pop dword ptr [ebx + 12]
push Yfenetrediv2
pop dword ptr [ebx + 16]
mov eax, pEtoile
ret
NouvelleEtoile ENDP  ;NouvelleEtoile= New Star

Random PROC Limite:DWORD
mov eax, NombrePrRandom
mov ecx, 23
mul ecx
add eax, 7
and eax, 0FFFFFFFFh
ror eax, 1
xor eax, NombrePrRandom
mov NombrePrRandom, eax
mov ecx, Limite ;Limit
xor edx, edx
div ecx
mov eax, edx
ret
Random ENDP
end start