.486
.model flat, stdcall
option casemap: none

; API functions
; ------------------------------------------------------------------------------
include  \masm32\include\windows.inc
include  \masm32\include\user32.inc
include  \masm32\include\kernel32.inc
include  \masm32\include\comctl32.inc
include  \masm32\include\masm32.inc
include  \masm32\include\shell32.inc
include  \masm32\include\comdlg32.inc
include  \masm32\include\gdi32.inc
include  \masm32\include\advapi32.inc

includelib  \masm32\lib\user32.lib
includelib  \masm32\lib\kernel32.lib
includelib  \masm32\lib\comctl32.lib
includelib  \masm32\lib\masm32.lib
includelib  \masm32\lib\shell32.lib
includelib  \masm32\lib\comdlg32.lib
includelib  \masm32\lib\gdi32.lib
includelib  \masm32\lib\advapi32.lib

include \masm32\macros\macros.asm
; ------------------------------------------------------------------------------

; Prototype 
; ------------------------------------------------------------------------------
DialogProc    PROTO : HWND, : UINT, : WPARAM, : LPARAM
; Macros
; ------------------------------------------------------------------------------
m2m MACRO M1, M2
	push M2
	pop  M1
ENDM


GETV MACRO dVar
	mov eax,dVar 
  EXITM <eax>
ENDM
; ------------------------------------------------------------------------------
.const
; Resource ids
; ------------------------------------------------------------------------------
IDD_DLG1  	  equ 101
IDI_ICON      equ 200
;IDC_TIMER	= 10

COLORDLG		equ 00000000h ; Dialog colour (Natural window coour is 00D8E9ECh)

; Required data

.data
szTitle    db "Starfieldblank", 0


.data?
hInstance	dd	?
hIcon     HICON ?
brush		dd	?
hBgColor     	HBRUSH		?
WindowRect    	RECT		<?>
rStarfield		RECT		<?>
rClientWindow	RECT		<?>
PosRct		RECT		<?>
hbmp		HANDLE		?
chdc		HDC		?
TimerID		DWORD		?


.code

start:
INVOKE GetModuleHandle, NULL
mov hInstance, eax

INVOKE LoadIcon, eax, IDI_ICON 
mov hIcon, eax
INVOKE InitCommonControls
; ---------------------------------------------
;   Call the dialog box stored in resource file
; ---------------------------------------------
INVOKE DialogBoxParam, hInstance, IDD_DLG1 , NULL, ADDR DialogProc, 0
INVOKE ExitProcess, 0

; Dialog procedure
; ------------------------------------------------------------------------------
DialogProc proc hWnd: HWND, uMsg: UINT, wParam: WPARAM, lParam: LPARAM

LOCAL	ps:PAINTSTRUCT
LOCAL	hdc:HDC

.IF uMsg == WM_INITDIALOG

INVOKE SetWindowText, hWnd, addr szTitle 
INVOKE SendMessage, hWnd, WM_SETICON,ICON_SMALL, hIcon  
; ################################# creats colour window		
INVOKE CreateSolidBrush,COLORDLG; <-creats colour window!!!		
mov hBgColor,eax


INVOKE GetClientRect,hWnd,ADDR WindowRect
mov hdc,FUNC(GetDC,hWnd)
mov chdc,FUNC(CreateCompatibleDC,hdc); creats window
mov hbmp,FUNC(CreateCompatibleBitmap,hdc,WindowRect.right,WindowRect.bottom); creats window
INVOKE SelectObject,chdc,hbmp
mov rClientWindow.top,1
mov rClientWindow.left,1
m2m rClientWindow.right,WindowRect.right
m2m rClientWindow.bottom,WindowRect.bottom    
dec rClientWindow.bottom
dec rClientWindow.right
INVOKE FillRect,chdc,ADDR WindowRect,hBgColor ; color for about title


INVOKE IntersectClipRect,chdc,rClientWindow.left,rClientWindow.top,rClientWindow.right,rClientWindow.bottom


m2m rStarfield.right,rClientWindow.right
sub rStarfield.right,5
add rStarfield.top,GETV(rClientWindow.bottom)
add rStarfield.bottom,eax	

INVOKE ReleaseDC,hWnd,hdc	

;mov TimerID,FUNC(SetTimer,hWnd,IDC_TIMER,SCROLLSPEED,NULL)

.elseif uMsg == WM_PAINT
INVOKE BeginPaint,hWnd,addr ps
mov hdc,eax
;INVOKE FillRect,chdc,ADDR rStarfield,hBgColor


INVOKE BitBlt,hdc,0,0,WindowRect.right,WindowRect.bottom,chdc,0,0,SRCCOPY
INVOKE EndPaint,hWnd,addr ps

	;.elseif uMsg == WM_TIMER
	;add rStarfield.top,GETV(ScrollOffset)
	;add rStarfield.bottom,eax			
	;.if SDWORD PTR rStarfield.top >= GETV(rClientWindow.bottom)
	;mov ScrollOffset,-1			
	;.endif		
	;	INVOKE InvalidateRect,hWnd,NULL,FALSE

	.elseif uMsg == WM_CLOSE 
	mov rStarfield.top,0
	mov rStarfield.bottom,0
	mov rStarfield.left,0
	mov rStarfield.right,0
		INVOKE DeleteDC,chdc 
		INVOKE DeleteObject,hbmp
		INVOKE KillTimer,hWnd,TimerID
		INVOKE EndDialog,hWnd,NULL
	
	.else
		return FALSE    
	.endif
		return TRUE

xor eax,eax 
	Ret
DialogProc endp

end start